(define (domain DOMblocksworldbw3)
  (:objects   ontable_c - :boolean
  ontable_b - :boolean
  ontable_a - :boolean
  on_c_b - :boolean
  on_c_a - :boolean
  on_b_c - :boolean
  on_b_a - :boolean
  clear_c - :boolean
  clear_a - :boolean
  clear_b - :boolean
  on_a_c - :boolean
  on_a_b - :boolean
   )
(:action totable_c
  :precondition (:and (= clear_c true) (:or (= on_c_b true) (= on_c_a true) ) )
  :effect (:set ontable_c true) (:when (= on_c_b true) (:set on_c_b false) (:set clear_b true) ) (:when (= on_c_a true) (:set on_c_a false) (:set clear_a true) )  
  :observation clear_c clear_b clear_a ontable_c ontable_b ontable_a 
)
(:action totable_b
  :precondition (:and (= clear_b true) (:or (= on_b_c true) (= on_b_a true) ) )
  :effect (:set ontable_b true) (:when (= on_b_c true) (:set on_b_c false) (:set clear_c true) ) (:when (= on_b_a true) (:set on_b_a false) (:set clear_a true) )  
  :observation clear_c clear_b clear_a ontable_c ontable_b ontable_a 
)
(:action totable_a
  :precondition (:and (= clear_a true) (:or (= on_a_c true) (= on_a_b true) ) )
  :effect (:set ontable_a true) (:when (= on_a_c true) (:set on_a_c false) (:set clear_c true) ) (:when (= on_a_b true) (:set on_a_b false) (:set clear_b true) )  
  :observation clear_c clear_b clear_a ontable_c ontable_b ontable_a 
)
(:action fromtable_c_b
  :precondition (:and (= ontable_c true) (= clear_c true) (= clear_b true) )
  :effect (:set ontable_c false) (:set clear_b false) (:set on_c_b true) 
  :observation clear_c clear_b clear_a ontable_c ontable_b ontable_a 
)
(:action fromtable_c_a
  :precondition (:and (= ontable_c true) (= clear_c true) (= clear_a true) )
  :effect (:set ontable_c false) (:set clear_a false) (:set on_c_a true) 
  :observation clear_c clear_b clear_a ontable_c ontable_b ontable_a 
)
(:action fromtable_b_c
  :precondition (:and (= ontable_b true) (= clear_b true) (= clear_c true) )
  :effect (:set ontable_b false) (:set clear_c false) (:set on_b_c true) 
  :observation clear_c clear_b clear_a ontable_c ontable_b ontable_a 
)
(:action fromtable_b_a
  :precondition (:and (= ontable_b true) (= clear_b true) (= clear_a true) )
  :effect (:set ontable_b false) (:set clear_a false) (:set on_b_a true) 
  :observation clear_c clear_b clear_a ontable_c ontable_b ontable_a 
)
(:action fromtable_a_c
  :precondition (:and (= ontable_a true) (= clear_a true) (= clear_c true) )
  :effect (:set ontable_a false) (:set clear_c false) (:set on_a_c true) 
  :observation clear_c clear_b clear_a ontable_c ontable_b ontable_a 
)
(:action fromtable_a_b
  :precondition (:and (= ontable_a true) (= clear_a true) (= clear_b true) )
  :effect (:set ontable_a false) (:set clear_b false) (:set on_a_b true) 
  :observation clear_c clear_b clear_a ontable_c ontable_b ontable_a 
)
(:action move_c_b
  :precondition (:and (= clear_c true) (= clear_b true) (:or (= on_c_b true) (= on_c_a true) ) )
  :effect (:set clear_b false) (:set on_c_b true) (:when (= on_c_b true) (:set clear_b true) (:set on_c_b false) ) (:when (= on_c_a true) (:set clear_a true) (:set on_c_a false) )  
  :observation clear_c clear_b clear_a ontable_c ontable_b ontable_a 
)
(:action move_c_a
  :precondition (:and (= clear_c true) (= clear_a true) (:or (= on_c_b true) (= on_c_a true) ) )
  :effect (:set clear_a false) (:set on_c_a true) (:when (= on_c_b true) (:set clear_b true) (:set on_c_b false) ) (:when (= on_c_a true) (:set clear_a true) (:set on_c_a false) )  
  :observation clear_c clear_b clear_a ontable_c ontable_b ontable_a 
)
(:action move_b_c
  :precondition (:and (= clear_b true) (= clear_c true) (:or (= on_b_c true) (= on_b_a true) ) )
  :effect (:set clear_c false) (:set on_b_c true) (:when (= on_b_c true) (:set clear_c true) (:set on_b_c false) ) (:when (= on_b_a true) (:set clear_a true) (:set on_b_a false) )  
  :observation clear_c clear_b clear_a ontable_c ontable_b ontable_a 
)
(:action move_b_a
  :precondition (:and (= clear_b true) (= clear_a true) (:or (= on_b_c true) (= on_b_a true) ) )
  :effect (:set clear_a false) (:set on_b_a true) (:when (= on_b_c true) (:set clear_c true) (:set on_b_c false) ) (:when (= on_b_a true) (:set clear_a true) (:set on_b_a false) )  
  :observation clear_c clear_b clear_a ontable_c ontable_b ontable_a 
)
(:action move_a_c
  :precondition (:and (= clear_a true) (= clear_c true) (:or (= on_a_c true) (= on_a_b true) ) )
  :effect (:set clear_c false) (:set on_a_c true) (:when (= on_a_c true) (:set clear_c true) (:set on_a_c false) ) (:when (= on_a_b true) (:set clear_b true) (:set on_a_b false) )  
  :observation clear_c clear_b clear_a ontable_c ontable_b ontable_a 
)
(:action move_a_b
  :precondition (:and (= clear_a true) (= clear_b true) (:or (= on_a_c true) (= on_a_b true) ) )
  :effect (:set clear_b false) (:set on_a_b true) (:when (= on_a_c true) (:set clear_c true) (:set on_a_c false) ) (:when (= on_a_b true) (:set clear_b true) (:set on_a_b false) )  
  :observation clear_c clear_b clear_a ontable_c ontable_b ontable_a 
)
)

(define (problem PROblocksworldbw3)
   (:domain DOMblocksworldbw3)
   (:init
     (:set ontable_b :in { true false })
     (:set ontable_a :in { true false })
     (:set on_c_b :in { true false })
     (:set on_c_a :in { true false })
     (:set on_b_c :in { true false })
     (:set on_b_a :in { true false })
     (:set clear_c :in { true false })
     (:set clear_a :in { true false })
     (:set clear_b :in { true false })
     (:set on_a_c :in { true false })
     (:set on_a_b :in { true false })
     (:set ontable_c :in { true false }
   :assert (:and (:or (:not (:and (= on_c_b true) (= on_b_c true) )) (= clear_c true) ) (:or (:not (:and (= on_a_b true) (= on_b_c true) )) (= clear_a true) ) (:or (:not (:and (= on_c_a true) (= on_a_c true) )) (= clear_c true) ) (:or (:not (:and (= on_b_a true) (= on_a_c true) )) (= clear_b true) ) (:or (:not (:and (= on_b_c true) (= on_c_b true) )) (= clear_b true) ) (:or (:not (:and (= on_a_c true) (= on_c_b true) )) (= clear_a true) ) (:or (:not (:and (= on_c_a true) (= on_a_b true) )) (= clear_c true) ) (:or (:not (:and (= on_b_a true) (= on_a_b true) )) (= clear_b true) ) (:or (:not (:and (= on_b_c true) (= on_c_a true) )) (= clear_b true) ) (:or (:not (:and (= on_a_c true) (= on_c_a true) )) (= clear_a true) ) (:or (:not (:and (= on_c_b true) (= on_b_a true) )) (= clear_c true) ) (:or (:not (:and (= on_a_b true) (= on_b_a true) )) (= clear_a true) ) (:not (:and (= on_b_c true) (= on_c_b true) )) (:not (:and (= on_a_c true) (= on_c_a true) )) (:not (:and (= on_c_b true) (= on_b_c true) )) (:not (:and (= on_a_b true) (= on_b_a true) )) (:not (:and (= on_c_a true) (= on_a_c true) )) (:not (:and (= on_b_a true) (= on_a_b true) )) (:or (:not (= on_a_b true)) (:not (= on_a_c true)) ) (:or (:not (= on_b_a true)) (:not (= on_b_c true)) ) (:or (:not (= on_a_c true)) (:not (= on_a_b true)) ) (:or (:not (= on_c_a true)) (:not (= on_c_b true)) ) (:or (:not (= on_b_c true)) (:not (= on_b_a true)) ) (:or (:not (= on_c_b true)) (:not (= on_c_a true)) ) (:or (:not (= on_c_b true)) (:not (= on_c_b true)) ) (:or (:not (= on_c_a true)) (:not (= on_c_a true)) ) (:or (:not (= on_b_a true)) (:not (= on_c_a true)) ) (:or (:not (= on_a_b true)) (:not (= on_c_b true)) ) (:or (:not (= on_c_a true)) (:not (= on_b_a true)) ) (:or (:not (= on_b_c true)) (:not (= on_b_c true)) ) (:or (:not (= on_b_a true)) (:not (= on_b_a true)) ) (:or (:not (= on_a_c true)) (:not (= on_b_c true)) ) (:or (:not (= on_c_b true)) (:not (= on_a_b true)) ) (:or (:not (= on_b_c true)) (:not (= on_a_c true)) ) (:or (:not (= on_a_c true)) (:not (= on_a_c true)) ) (:or (:not (= on_a_b true)) (:not (= on_a_b true)) ) (:or (:not (:or (= on_b_c true) (= on_a_c true) )) (:not (= clear_c true)) ) (:or (:not (:or (= on_c_b true) (= on_a_b true) )) (:not (= clear_b true)) ) (:or (:not (:or (= on_c_a true) (= on_b_a true) )) (:not (= clear_a true)) ) (:or (:not (:not (:or (= on_b_c true) (= on_a_c true) ))) (= clear_c true) ) (:or (:not (:not (:or (= on_c_b true) (= on_a_b true) ))) (= clear_b true) ) (:or (:not (:not (:or (= on_c_a true) (= on_b_a true) ))) (= clear_a true) ) (:or (:not (:not (:or (= on_c_b true) (= on_c_a true) ))) (= ontable_c true) ) (:or (:not (:not (:or (= on_b_c true) (= on_b_a true) ))) (= ontable_b true) ) (:or (:not (:not (:or (= on_a_c true) (= on_a_b true) ))) (= ontable_a true) ) (:or (:not (:or (= on_c_b true) (= on_c_a true) )) (:not (= ontable_c true)) ) (:or (:not (:or (= on_b_c true) (= on_b_a true) )) (:not (= ontable_b true)) ) (:or (:not (:or (= on_a_c true) (= on_a_b true) )) (:not (= ontable_a true)) ) )   )
  )

  (:goal (:and (= on_a_b true) (= on_b_c true))
  )
)




