(define (domain DOMbtcsp1_5)
  (:objects clogged_t1 - :boolean
            in_toilet_p5_t1 - :boolean
            in_toilet_p4_t1 - :boolean
in_toilet_p3_t1 - :boolean
in_toilet_p2_t1 - :boolean
in_toilet_p1_t1 - :boolean
explosive_odor_p5 - :boolean
armed_bomb_p5 - :boolean
explosive_odor_p4 - :boolean
armed_bomb_p4 - :boolean
explosive_odor_p3 - :boolean
armed_bomb_p3 - :boolean
explosive_odor_p2 - :boolean
armed_bomb_p2 - :boolean
explosive_odor_p1 - :boolean
armed_bomb_p1 - :boolean)
(:action dunk_p5_t1
  :precondition (:not (= clogged_t1 true))
  :effect (:set armed_bomb_p5 false) (:set clogged_t1 true) 
  :observation explosive_odor_p5 explosive_odor_p4 explosive_odor_p3 explosive_odor_p2 explosive_odor_p1 
)
(:action dunk_p4_t1
  :precondition (:not (= clogged_t1 true))
  :effect (:set armed_bomb_p4 false) (:set clogged_t1 true) 
  :observation explosive_odor_p5 explosive_odor_p4 explosive_odor_p3 explosive_odor_p2 explosive_odor_p1 
)
(:action dunk_p3_t1
  :precondition (:not (= clogged_t1 true))
  :effect (:set armed_bomb_p3 false) (:set clogged_t1 true) 
  :observation explosive_odor_p5 explosive_odor_p4 explosive_odor_p3 explosive_odor_p2 explosive_odor_p1 
)
(:action dunk_p2_t1
  :precondition (:not (= clogged_t1 true))
  :effect (:set armed_bomb_p2 false) (:set clogged_t1 true) 
  :observation explosive_odor_p5 explosive_odor_p4 explosive_odor_p3 explosive_odor_p2 explosive_odor_p1 
)
(:action dunk_p1_t1
  :precondition (:not (= clogged_t1 true))
  :effect (:set armed_bomb_p1 false) (:set clogged_t1 true) 
  :observation explosive_odor_p5 explosive_odor_p4 explosive_odor_p3 explosive_odor_p2 explosive_odor_p1 
)
(:action flush_t1
  :effect (:set clogged_t1 false)
          (:when (= in_toilet_p1_t1 true)
                 (:set armed_bomb_p1 false))
(:when (= in_toilet_p3_t1 true) (:set armed_bomb_p3 false))
(:when (= in_toilet_p5_t1 true) (:set armed_bomb_p5 false))
(:when (= in_toilet_p2_t1 true) (:set armed_bomb_p2 false))
(:when (= in_toilet_p4_t1 true) (:set armed_bomb_p4 false))
(:set in_toilet_p1_t1 false)
(:set in_toilet_p3_t1 false)
(:set in_toilet_p5_t1 false)
(:set in_toilet_p2_t1 false)
(:set in_toilet_p4_t1 false)   
  :observation explosive_odor_p5 explosive_odor_p4 explosive_odor_p3 explosive_odor_p2 explosive_odor_p1 
)
(:action sniff_p5
  :effect (:when (= armed_bomb_p5 true) (:set explosive_odor_p5 true))
  :observation explosive_odor_p5 explosive_odor_p4 explosive_odor_p3 explosive_odor_p2 explosive_odor_p1 
)
(:action sniff_p4
  :effect (:when (= armed_bomb_p4 true) (:set explosive_odor_p4 true))
  :observation explosive_odor_p5 explosive_odor_p4 explosive_odor_p3 explosive_odor_p2 explosive_odor_p1 
)
(:action sniff_p3
  :effect (:when (= armed_bomb_p3 true) (:set explosive_odor_p3 true))
  :observation explosive_odor_p5 explosive_odor_p4 explosive_odor_p3 explosive_odor_p2 explosive_odor_p1 
)
(:action sniff_p2
  :effect (:when (= armed_bomb_p2 true) (:set explosive_odor_p2 true))
  :observation explosive_odor_p5 explosive_odor_p4 explosive_odor_p3 explosive_odor_p2 explosive_odor_p1 
)
(:action sniff_p1
  :effect (:when (= armed_bomb_p1 true) (:set explosive_odor_p1 true))
  :observation explosive_odor_p5 explosive_odor_p4 explosive_odor_p3 explosive_odor_p2 explosive_odor_p1 
)
)
(define (problem PRObtcsp1_5)
   (:domain DOMbtcsp1_5)
   (:init
     (:set explosive_odor_p5 false)
     (:set explosive_odor_p4 false)
     (:set explosive_odor_p3 false)
     (:set explosive_odor_p2 false)
     (:set explosive_odor_p1 false)
     (:set clogged_t1 false)
     (:set in_toilet_p4_t1 :in { true false })
     (:set in_toilet_p3_t1 :in { true false })
     (:set in_toilet_p2_t1 :in { true false })
     (:set in_toilet_p1_t1 :in { true false })
     (:set armed_bomb_p5 :in { true false })
     (:set armed_bomb_p4 :in { true false })
     (:set armed_bomb_p3 :in { true false })
     (:set armed_bomb_p2 :in { true false })
     (:set armed_bomb_p1 :in { true false })
     (:set in_toilet_p5_t1 :in { true false })
     (:and (:or (= armed_bomb_p5 true) (= armed_bomb_p4 true) (= armed_bomb_p3 true) (= armed_bomb_p2 true) (= armed_bomb_p1 true) )
           (:not (:and (= armed_bomb_p4 true) (= armed_bomb_p5 true) ))
           (:not (:and (= armed_bomb_p3 true) (= armed_bomb_p5 true) ))
           (:not (:and (= armed_bomb_p2 true) (= armed_bomb_p5 true) ))
           (:not (:and (= armed_bomb_p1 true) (= armed_bomb_p5 true) ))
           (:not (:and (= armed_bomb_p5 true) (= armed_bomb_p4 true) ))
           (:not (:and (= armed_bomb_p3 true) (= armed_bomb_p4 true) ))
           (:not (:and (= armed_bomb_p2 true) (= armed_bomb_p4 true) ))
           (:not (:and (= armed_bomb_p1 true) (= armed_bomb_p4 true) ))
           (:not (:and (= armed_bomb_p5 true) (= armed_bomb_p3 true) ))
           (:not (:and (= armed_bomb_p4 true) (= armed_bomb_p3 true) ))
           (:not (:and (= armed_bomb_p2 true) (= armed_bomb_p3 true) ))
           (:not (:and (= armed_bomb_p1 true) (= armed_bomb_p3 true) ))
           (:not (:and (= armed_bomb_p5 true) (= armed_bomb_p2 true) ))
           (:not (:and (= armed_bomb_p4 true) (= armed_bomb_p2 true) ))
           (:not (:and (= armed_bomb_p3 true) (= armed_bomb_p2 true) ))
           (:not (:and (= armed_bomb_p1 true) (= armed_bomb_p2 true) ))
           (:not (:and (= armed_bomb_p5 true) (= armed_bomb_p1 true) ))
           (:not (:and (= armed_bomb_p4 true) (= armed_bomb_p1 true) ))
           (:not (:and (= armed_bomb_p3 true) (= armed_bomb_p1 true) ))
           (:not (:and (= armed_bomb_p2 true) (= armed_bomb_p1 true) )) )
      )
   (:goal (:and (:not (= armed_bomb_p5 true)) (:not (= armed_bomb_p4 true)) (:not (= armed_bomb_p3 true)) (:not (= armed_bomb_p2 true)) (:not (= armed_bomb_p1 true)) ))
)

