(define (domain blocks)
  (:model (:dynamics :deterministic) (:feedback :complete))
  (:types BLOCK)
  (:predicates (on BLOCK BLOCK)
               (clear BLOCK))
  (:objects table - BLOCK)

  (:action move
    :parameters ?x ?y ?z - BLOCK
    :precondition (:and (clear ?x) (clear ?z) (on ?x ?y)
                        (:not (= ?x ?z)) (:not (= ?x table)))
    :effect (:set (on ?x ?y) false)
            (:set (on ?x ?z) true)
            (:when (:not (= ?z table)) (:set (clear ?z) false))
            (:set (clear ?y) true)
  )
)

(define (problem p1)
  (:domain blocks)
  (:objects a b c - BLOCK)
  (:init (:set (on a table) true)
         (:set (on b table) true)
         (:set (on c b) true)
         (:set (clear a) true)
         (:set (clear b) false)
         (:set (clear c) true)
         (:set (clear table) true))
  (:goal (:and (on b a) (on c b))))

