//  Theseus
//  theMemoryMgmt.h -- Memory Management Implemetantion
//
//  Blai Bonet, Hector Geffner
//  Universidad Simon Bolivar, 1998, 1999, 2000, 2001, 2002

#ifndef _theMemoryMgmt_INCLUDE_
#define _theMemoryMgmt_INCLUDE_


#ifndef NDEBUG
extern void memoryReport( bool flag );
#endif


#if 0
///////////////////////////////////////////////////////////////////////////////
//
// Memory Management Class
//

class memoryMgmtClass
{
 public:
  // public const 
  enum allocationMode { standardMode, privateMode };
  static const unsigned initialClaimSize = 256;
  static const unsigned sizeInitialTable = 128;

 private:

  // internal classes
  struct memory_t {
    int       size;
    memory_t* next;
    char*     chunk;
  };

  struct memoryAreaTable_t {
    char* base;
    char* index;
    char* boundary;
  };

  // members
  memoryAreaTable_t* memoryAreaTable;
  memory_t*          freeList[sizeInitialTable];
  int                sizeMemoryAreaTable;
  int                numberMemoryAreas;
  unsigned           claimSize;

  // private methods 
  memoryMgmtClass( const memoryMgmtClass& pool );

  char*  allocateFromFreeList( size_t size );
  char*  allocateFromPool( size_t size );
  void   getNewMemoryArea( size_t size, int &i );
  int    getIndex( size_t size );

public:
  // members
  allocationMode     mode;

  // constructors/destructors
  memoryMgmtClass();
  ~memoryMgmtClass();

  // methods
  void   setAllocationMode( allocationMode newMode );
  char*  allocate( size_t size );
  void   deallocate( char *ptr );
  bool   goodSize( size_t size );
  void   clean( void );
};
#endif


#endif // _theMemoryMgmt_INCLUDE
